class MyThread extends Thread { 
	
	// nen teba referenn promnn thrd. Tda MyThread bude obsahovat instance mt
	int count; 

	MyThread(String name) { 
		super(name); // vol konstruktor nadtdy, pedv mu jmno vlkna jako parametr 
		count = 0; 
		start();     // startuje v konstruktoru, jeliko odkazuje na sebe, tak nen nutn kvalifikace    
	} 

	public void run() { // v potomkovi ze Thread musme pedefinovat run()
		System.out.println(getName() + " startuje"); 
		try {  
			do { 
				Thread.sleep(500); // zde kvalifikace nen nutn, protoe jsme v potomkovi ze Thread
				System.out.println("V " + getName() + ", ta je " + count); 
				count++; 
			} while(count < 5); 
		} 
		catch(InterruptedException exc) { 
			System.out.println(getName() + " perueno"); 
		} 
		System.out.println(getName() + " kon"); 
	} 
} 

class DediThread { // To nen potomek Thread, vytv se v n 'potomek'
	public static void main(String args[]) { 
		System.out.println("Hlavn vlkno startuje"); 

		MyThread mt = new MyThread("potomek"); 

		do { 
			System.out.print("."); 
			try { 
				Thread.sleep(100); //zde je nutna kvalifikace
				//if (mt.isAlive()) System.out.print("je zive") ;
			} 
			catch(InterruptedException exc) { 
				System.out.println("Hlavn vlkno perueno."); 
			} 
		} while (mt.count != 5); 

		System.out.println("Hlavn vlkno kon"); 
	} 
} 
