class MyThread implements Runnable { 
	int count; 
	Thread thrd; 

	MyThread(String name) { 
		thrd = new Thread(this, name); 
		count = 0; 
		thrd.start(); // start  
	} 

	public void run() { 
		System.out.println(thrd.getName() + " startuje"); 
		try {  
			do { 
				Thread.sleep(500); 
				System.out.println("Ve " + thrd.getName() + ", ta je " + count); 
				count++; 
			} while(count < 3); 
		} 
		catch(InterruptedException exc) { 
			System.out.println(thrd.getName() + " peruen"); 
		} 
		System.out.println(thrd.getName() + " kon"); 
	} 
} 

class Join { 
	public static void main(String args[]) { 
		System.out.println("Hlavn vlkno startuje"); 

		MyThread mt1 = new MyThread("potomek1"); 
		MyThread mt2 = new MyThread("potomek2"); 
		MyThread mt3 = new MyThread("potomek3"); 

		try { 
			mt3.thrd.join(); 
			System.out.println("potomek3 joined."); 
			mt2.thrd.join(); 
			System.out.println("potomek2 joined."); 
			mt1.thrd.join(); 
			System.out.println("potomek1 joined."); 
		} 
		catch(InterruptedException exc) { 
			System.out.println("Hlavn vlkno peruen"); 
		} 

		System.out.println("Hlavn vlkno kon"); 
	} 
}