// RZL pouv tryLock a umouje tm provdt nhradn innost po dobu ekn na zmek.

// Umonn jin innosti, pokud je zmek zabrn 
import java.util.concurrent.locks.ReentrantLock;

class Konto {
	static int konto = 1000;
	static final ReentrantLock l = new ReentrantLock();
}

class Koupe extends Thread {

	Koupe(String jmeno) { 
		super(jmeno);
	} 

	public void run()  { // vstupn bod vlkna
		System.out.println(getName() + " start."); 
		int lokal; 
		boolean done = true;

		while (done) {
			if (Konto.l.tryLock()) {
				try {
					lokal = Konto.konto;
					System.out.println(getName() + " milenkm ");    
					sleep(200);
					Konto.konto = lokal - 200;
					done = false; 
					System.out.println(getName() + " ukonen.");
				}
				catch (InterruptedException e) {} 
				finally {
					Konto.l.unlock();
				}
			} else {
				try{
					System.out.println("Jin innost 1");  // Simulujeme nhradn cinnost
					Thread.sleep(100);
				}
				catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	} 
} 

class Prodej extends Thread {

	Prodej(String jmeno) { 
		super(jmeno);
	}

	public void run() { // vstupn bod vlkna
		System.out.println(getName() + " start."); 
		int lokal;
		boolean done = true;

		while (done) {
			if (Konto.l.tryLock()) {
				try {
					lokal = Konto.konto;
					System.out.println(getName() + " co se d ");
					sleep(50);
					Konto.konto = lokal + 500;
					done = false; 
					System.out.println(getName() + " ukonen.");
				}
				catch (InterruptedException e) {}
				finally {
					Konto.l.unlock();
				} 
			} else {
				try{
					System.out.println("Jin innost 2");  // Simulujeme nhradn cinnost
					Thread.sleep(100);
				}
				catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}	
	} 
}  

class RZL {   

	public static void main (String args[]) throws InterruptedException {

		System.out.println("Hlavn vlkno startuje"); 
		Koupe nakup = new Koupe("nakupuji ");
		Prodej prodej = new Prodej ("prodvm "); 
		nakup.start();  // nebo zmnou prodej.start(); nakup.start(); 
		prodej.start(); // kdy chceme ukzat provdn Jin innosti 1
		nakup.join();
		prodej.join(); 
		System.out.println(Konto.konto); 
		System.out.println("Kon hlavn vlkno");
	} 
} 
