class MyThread implements Runnable { 
	int count; 
	String thrdName; 

	MyThread(String name) { // objekty z myThread mohou bt konstruktoru pedny s parametrem String
		count = 0; 
		thrdName = name;    // etzec slouc jako jmno vlkna
	} 

	public void run() { // vstupn bod vlkna
		System.out.println(thrdName + " startuje."); 
		try {  
			do { 
				Thread.sleep(500); 
				System.out.println("Ve vlknu " + thrdName + ", ta je " + count); 
				count++; 
			} while(count < 5); 
		} 
		catch(InterruptedException exc) { // nutno oetit peruen span
			System.out.println(thrdName + " peruen."); 
		} 
		System.out.println(thrdName + " ukonen."); 
	} 
} 

class Vlakno { 
	public static void main(String args[]) { 
		
		System.out.println("Hlavn vlkno startuje."); 

		// Nejdve konstruujeme MyThread objekt. M metodu run(), ale ostatn metody vlkna nem 
		MyThread mt = new MyThread("potomek"); 

		// Pak konstruuj vlkno z tohoto objektu, tm mu dodme start(), ...  
		Thread newThrd = new Thread(mt); 

		// A pak startujeme vpoet vlkna 
		newThrd.start(); // te b souasn metody main a run z newThrd

		do { 
			System.out.print("."); 
			try { 
				Thread.sleep(100); // sleep je statick metoda Thread, kvalifikovat
			} 
			catch(InterruptedException exc) { // nutno oetit peruen span 
				System.out.println("Hlavn vlkno peruen."); 
			} 
		} while (mt.count != 5); 

		System.out.println("Kon hlavn vlkno."); 
	} 
} // pi opakovanm spoutn se vsledky mohou liit (rychlostn zvislosti)
