class MyThread extends Thread {
	int count;

	MyThread(String name) {
		super(name); // vol konstruktor nadtdy a ped mu parametr jmno vlkna
		count = 0;
	}

	public void run() { // vstupn bod vlkna
		System.out.println(getName() + " startuje.");
		try {
			do {
				Thread.sleep(500); // Kvalifikace nen nutn
				System.out.println("Ve vlknu " + getName() + ", ta je " + count);
				count++;
			} while (count < 5);
		} catch (InterruptedException exc) { // nutno oetit peruen span
			System.out.println(getName() + " peruen.");
		}
		System.out.println(getName() + " ukonen.");
	}
}

class Vlakno {
	public static void main(String args[]) {
		System.out.println("Hlavn vlkno startuje.");

		// Nejdve konstruujeme MyThread objekt.
		MyThread mt = new MyThread("potomek"); // objekt mt je vlkno, m jmno 'potomek', nemus mt ale dn

		// A pak startujeme vpoet vlkna
		mt.start();

		do {
			System.out.print(".");
			try {
				Thread.sleep(100);               // Kvalifikace je nutn
			} catch (InterruptedException exc) { // nutno oetit peruen
				// span
				System.out.println("Hlavn vlkno peruen.");
			}
		} while (mt.count != 5);

		System.out.println("Kon hlavn vlkno.");
	}
} // pi opakovanm spoutn se vsledky mohou liit (rychlostn zvislosti)
