// vlkno se rozbhne v okamiku jeho vytvoen
// jmno lze vlknu piadit a v okamiku sputn
class MyThread implements Runnable {	
	int count; 
	Thread thrd; // odkaz na vlkno je uloen v promnn thrd

	// Uvnit konstruktoru vytv nov vlkno konstruktorem Thread. 
	MyThread(String name) { 
		thrd = new Thread(this, name); // vytvo vlkno a piad jmno
		count = 0;                     // Konstruktor Thread lze rzn parametrizovat
		thrd.start();                  // startuje vlkno rovnou v konstruktoru 
	} 

	// Zatek exekuce vlkna 
	public void run() { 
		System.out.println(thrd.getName() + " startuje."); 
		try {  
			do { 
				Thread.sleep(500); 
				System.out.println("V potomkovi " + thrd.getName() + ", ta je " + count); 
				count++; 
			} while(count < 5); 
		} 
		catch(InterruptedException exc) { 
			System.out.println(thrd.getName() + " peruen."); 
		} 
		System.out.println(thrd.getName() + " ukonen."); 
	} 
} 

class VlaknoLepsi { 
	public static void main(String args[]) { 
		System.out.println("Hlavn vlkno startuje."); 

		MyThread mt = new MyThread("potomek"); // v konstruktoru se i spust

		do { 
			System.out.print("."); 
			try { 
				Thread.sleep(100); 
			} 
			catch(InterruptedException exc) { 
				System.out.println("Hlavn vlkno peruen."); 
			} 
		} while (mt.count != 5); 

		System.out.println("Hlavn vlkno kon."); 
	} 
}  // tisky z tto modifikace jsou stejn jako pedchoz
