class MyThread implements Runnable { 
	int count; 
	Thread thrd; 

	MyThread(String name) { 
		thrd = new Thread(this, name); // vytvo vlkno thrd na objektu tdy MyThread
		count = 0; 
		thrd.start(); // startuje vlkno thrd    
	} 

	public void run() { 
		System.out.println(thrd.getName() + " startuje"); 
		try {  
			do { 
				Thread.sleep(500); 
				System.out.println("Ve " + thrd.getName() + ", ta je " + count); 
				count++; 
			} while(count < 3); 
		} 
		catch(InterruptedException exc) { 
			System.out.println(thrd.getName() + " peruen"); 
		} 
		System.out.println(thrd.getName() + " ukonen"); 
	} 
} 

class ViceVlaken { 
	public static void main(String args[]) { 
		System.out.println("Hlavn vlkno startuje"); 

		MyThread mt1 = new MyThread("potomek1");  // vytvoen 3 vlken a jejich sputn
		MyThread mt2 = new MyThread("potomek2");  // v poad 1, 2, 3. Vpisy ta se pi
		MyThread mt3 = new MyThread("potomek3");  // opakopvanm spoutn mohou liit

		do { 
			System.out.print("."); 
			try { 
				Thread.sleep(100); 
			} 
			catch(InterruptedException exc) { 
				System.out.println("Hlavn vlkno peruen"); 
			} 
		//zajist, e vechna vlkna potomk ji skonila
		} while (mt1.count < 3 || 
				mt2.count < 3 || 
				mt3.count < 3); 
		//   } while (mt1.thrd.isAlive() || 
		//            mt2.thrd.isAlive() || 
		//            mt3.thrd.isAlive()); 

		System.out.println("Hlavn vlkno kon"); 
	} 
} 