class MyThread extends Thread { 
	int count; 

	MyThread(String name) { 
		super(name); 
		count = 0; 
		start(); // start  
	} 

	public void run() { 
		System.out.println(getName() + " startuje"); 
		try {  
			do { 
				Thread.sleep(500); 
				System.out.println("Ve " + getName() + ", ta je " + count); 
				count++; 
			} while(count < 3); 
		} 
		catch(InterruptedException exc) { 
			System.out.println(getName() + " peruen"); 
		} 
		System.out.println(getName() + " ukonen"); 
	} 
} 

class ViceVlaken { 
	public static void main(String args[]) { 
		System.out.println("Hlavn vlkno startuje"); 

		MyThread mt1 = new MyThread("potomek1"); 
		MyThread mt2 = new MyThread("potomek2"); 
		MyThread mt3 = new MyThread("potomek3"); 

		do { 
			System.out.print("."); 
			try { 
				Thread.sleep(100); 
			} 
			catch(InterruptedException exc) { 
				System.out.println("Hlavn vlkno peruen"); 
			} 
			//    } while (mt1.count < 3 || 
			//             mt2.count < 3 || 
			//             mt3.count < 3); 
		} while (mt1.isAlive() || 
				 mt2.isAlive() || 
				 mt3.isAlive()); 

		System.out.println("Hlavn vlkno kon"); 
	} 
} 