class Priority implements Runnable { 
	int count; 
	Thread thrd; 

	static boolean stop = false; 
	static String currentName; 

	Priority(String name) { 
		thrd = new Thread(this, name); 
		count = 0; 
		currentName = name; 
	} 

	public void run() { 
		System.out.println(thrd.getName() + " start "); 
		do { 
			count++; 

			if(currentName.compareTo(thrd.getName()) != 0) { 
				currentName = thrd.getName(); 
				System.out.println("Ve " + currentName); 
			} 

		} while(stop == false && count < 500); 
		stop = true; 

		System.out.println("\n" + thrd.getName() + " kon"); 
	} 
} 

class Priorita { 
	public static void main(String args[]) { 
		Priority mt1 = new Priority("Vysok Priorita"); 
		Priority mt2 = new Priority("Nzk Priorita"); 

		// nastaveni priorit 
		mt1.thrd.setPriority(Thread.NORM_PRIORITY + 2); // priorita 7 
		mt2.thrd.setPriority(Thread.NORM_PRIORITY - 2); // priorita 3

		// start vlaken 
		mt1.thrd.start(); 
		mt2.thrd.start(); 

		try { 
			mt1.thrd.join(); 
			mt2.thrd.join(); 
		} 
		catch(InterruptedException exc) { 
			System.out.println("Hlavn vlkno kon"); 
		} 

		System.out.println("Vlkno s velkou prioritou natalo " + mt1.count); 
		System.out.println("Vlkno s malou prioritou natalo " + mt2.count); 
	} 
}
