// S prioritami, projev se v OS s Time-Slicing

class Priority extends Thread { 
	int count; 

	static boolean stop = false; // zastav vlkno mtx, kdy skon mty
	static String currentName;   // jmno procesu, kter prv b

	Priority(String name) { 
		super(name);
		count = 0; 
		currentName = name; 
	} 

	public void run() { 
		System.out.println(getName() + " start "); 
		do { 
			count++; // ta iterac

			if(currentName.compareTo(getName()) != 0) {  // kontrola jmna vlkna v currentName
				currentName = getName();                 // s aktulnm. Pi != zaznamen a vype
				System.out.println("Ve " + currentName); // jmno aktulnho
			} 

		} while(stop == false && count < 500); // dv monosti ukonen bhu vlkna
		stop = true;                           // pokud skonilo jedno, tak pak skon i druh vlkno

		System.out.println("\n" + getName() + " kon"); 
	} 
} 

class Priorita { 
	public static void main(String args[]) { 
		Priority mt1 = new Priority("Vysok Priorita"); // JVM to me, ale nemus respektovat
		Priority mt2 = new Priority("Nzk Priorita"); 

		// nastaven priorit 
		mt1.setPriority(Thread.NORM_PRIORITY + 5); // JVM to nemus respektovat
		mt2.setPriority(Thread.NORM_PRIORITY); 

		// start vlken 
		mt1.start(); 
		mt2.start();
		
		// main ek na ukonen mt1, mt2
		try { 
			mt1.join(); 
			mt2.join(); 
		} 
		catch(InterruptedException exc) { 
			System.out.println("Hlavn vlkno kon"); 
		} 

		System.out.println("Vlkno s velkou prioritou natalo " + mt1.count); 
		System.out.println("Vlakno s malou prioritou natalo " + mt2.count); 
	} 
}
