//RZRL pouv lock a unlock k prostmu uzamen kritickch sekc manipulujcch s kontem. 
// Co funguje jako dvj pklad.

// Oeten kritickch sekc zmkem
import java.util.concurrent.locks.ReentrantLock;

class Konto {
	static int konto = 1000;
	static final ReentrantLock l = new ReentrantLock();
}

class Koupe extends Thread {

	Koupe(String jmeno) { 
		super(jmeno);
	} 

	public void run()  { // vstupn bod vlkna
		System.out.println(getName() + " start."); 
		int lokal;
		
		Konto.l.lock();  // zamknut zmku ze tdy Konto 
		try { 
			lokal = Konto.konto;
			System.out.println(getName() + " milenkm ");    
			sleep(200);
			Konto.konto = lokal - 200; 
			System.out.println(getName() + " ukonen.");
		}
		catch (InterruptedException e) {} 
		finally {
			Konto.l.unlock();  // odemknut zmku ze tdy Konto
		}
	} 
} 

class Prodej extends Thread {

	Prodej(String jmeno) { 
		super(jmeno);
	}

	public void run() { // vstupn bod vlkna
		System.out.println(getName() + " start."); 
		int lokal;
		Konto.l.lock();
		try {
			lokal = Konto.konto;
			System.out.println(getName() + " co se d ");
			sleep(2);
			Konto.konto = lokal + 500;
			System.out.println(getName() + " ukonen.");
		}
		catch (InterruptedException e) {}
		finally {
			Konto.l.unlock();
		} 
	} 
}  

class RZRL {    

	public static void main (String args[]) throws InterruptedException {
		
		System.out.println("Hlavn vlkno startuje"); 
		Koupe nakup = new Koupe("nakupuji ");
		Prodej prodej = new Prodej ("prodvm "); 
		nakup.start();
		prodej.start(); 
		nakup.join();
		prodej.join();
		System.out.println(Konto.konto); 
		System.out.println("Kon hlavn vlkno");
	} 
} 
